import sys
import math
import random

curtest = 59

was = set()

def test(L, R, d):
    global curtest
    global was
    f = open("%02d" % curtest, "w")
    print(L, R, file=f)
    print(len(d), file=f)
    print(*d, file=f)
    f.close()
    curtest += 1

def solve(L, R, d):
    n = len(d)
    p = [0] * (n + 1)
    for i in range(n):
        p[i + 1] = p[i] + d[i]
    
    si = 0
    for ti in range(1, n + 1):
        while p[ti] - p[si] > R:
            si += 1
        if L <= p[ti] - p[si] <= R:
            return (si, ti)

    return (-1, -1)

def rand_arr(n, m):
    a = [0] * n
    for i in range(n):
        a[i] = random.randint(1, m)
    return a

def genLR(a, p, q):   
    n = len(a)
    s = random.randint(0, n - round(n * p))
    t = random.randint(s + 1, s + round(n * p))
    v = sum(a[s:t + 1])
    p = a[random.randint(0, n - 1)]
    L = v - random.randint(0, p // q)
    R = v + random.randint(0, p // q)
    return (L, R)

def genLRNo(a, p, q):   
    n = len(a)
    s = random.randint(0, n - round(n * p))
    t = random.randint(s + 1, s + round(n * p))
    v = sum(a[s:t + 1])
    p = a[random.randint(0, n - 1)]
    R = v - random.randint(0, p // q)
    L = R - random.randint(0, p // q)
    return (L, R)

random.seed("iwkdo")

# subtask 3: n <= 300000
print(curtest)
for n, z, p in [(300000, 10**9, 0.3), (240000, 10**9, 0.7), (243500, 10**9, 0.1)]:
    while True:
        d = rand_arr(n, z)
        L, R = genLRNo(d, p, 10000)
        s, t = solve(L, R, d)
        if t == -1:
            break
    test(L, R, d)
    print(s, t)

