def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num**0.5) + 1):
        if num % i == 0:
            return False
    return True

def get_nonprime_partitions(n):
    def partitions(n, i):
        if n == 0:
            yield []
        for x in range(i, n + 1):
            if not is_prime(x):
                for p in partitions(n - x, x):
                    yield [x] + p

    return list(partitions(n, 1))

n = int(input())
partitions = get_nonprime_partitions(n)
for partition in partitions:
    print('+'.join(map(str, partition)))