#include "testlib.h"
#include <cmath>
using namespace std;

typedef long long ll;

ll MAXN = (ll) 1e18;
ll MAXK = MAXN - 1;
ll MAXQ = 5000;

int main(int argc, char **argv)
{
    registerValidation(argc, argv);
    int g = validator.group() == "" ? 5 : validator.group()[0] - '0';

    if (g == 1) { MAXN = 5000; }
    if (g == 2) { MAXN = 5000; }
    if (g == 3) { MAXK = 5000; }
    if (g == 4) { MAXK = 100'000; }

    ll n = inf.readLong(2, MAXN, "n");
    inf.readEoln();
    ll k = inf.readLong(1, min(n - 1, MAXK), "k");
    inf.readEoln();
    if (g == 1) { ensuref(k == n - 1, "k = n - 1 in group 1"); }

    int q = inf.readInt(1, min(k + 1, MAXQ), "q");
    if (g == 1 || g == 2) { ensuref(q == k + 1, "q = k + 1 in groups 1 and 2"); }
    inf.readEoln();
    vector<ll> t = inf.readLongs(q, 1, k + 1, "t");
    inf.readEoln();

    for (int i = 0; i < q - 1; i++) {
        ensuref(t[i] < t[i + 1], "t_i must be ascending");
    }
    inf.readEof();

    return 0;
}
